d("customCartView",['ccrz', 'util', 'customCartModel'], function(CCRZ, UTIL, customCartModel) {

    var runDefaultJsFunctions = function(){
        initTooltip();
        initCustomForms();
        businessLayout();
        initCustomLabel();
        initRetinaCover();
        initCustomHover();
    }

    return {
        staticResourceUrls: {
            egressTheme: ''
        },
        extendcustomCartView: function() {
            CCRZ.custom = _.extend(CCRZ.custom||{}); 
            CCRZ.custom.views = _.extend(CCRZ.custom.views||{}); 
            CCRZ.custom.models = _.extend(CCRZ.custom.models||{}); 
            CCRZ.remoteActions = _.extend(CCRZ.remoteActions||{});
            // Fix for new user cart not loading
            if(CCRZ.pagevars && CCRZ.pagevars.queryParams && CCRZ.pagevars.queryParams.isNewUser){
                let isRelead = window.sessionStorage.getItem('isReloadPage');
                if(isRelead !== 'false'){
                    window.sessionStorage.setItem('isReloadPage', false);
                    window.location.reload();
                }
            }
            CCRZ.remoteActions.cartPageRemoting =  _.extend(CCRZ.RemoteInvocation,{ 
                className : 'DCMB2B_custCart_controller', 
                getRelatedProducts : function(reqData, callback){ 
                    this.invokeCtx('getRelatedProducts',
                        reqData,
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                },
                updateAutoRenew : function( reqData,callback){ 
                    this.invokeCtx('updateAutoRenew', 
                        reqData,  
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                },
                addCouponSPT : function( reqData,callback){ 
                    this.invokeCtx('addCouponSPT', 
                        reqData,  
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                },
                removeCouponSPT : function( reqData,callback){ 
                    this.invokeCtx('removeCouponSPT', 
                        reqData,  
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                }
            });
            setTimeout(() => {
                runDefaultJsFunctions();
            }, 500);
            if(CCRZ.cartDetailView){
                let view = CCRZ.cartDetailView;
                view.delegateEvents(_.extend(view.events, {
                    "click .plus" : addSingleQty,
                    "click .minus" : removeSingleQty,
                    "click .removeItemButton" : removeItemButton,
                    "click .autoRenew" : autoRenew, 
                    "click .productName": gotoProductDetail,
                    "change .input-text.entry" : changeQuantity,
                    'click .abandonCart' : abandonCurrentCart,
                    'click .checkOutBtnCustom' : goToCheckoutCustom,
                    'click #addCouponBtn' : handleApplyCoupon,
                    'click #includedItems' : handleIncludedItems,
                    'keypress #addCouponIdCart' : handleCouponKeyPress,
                    'keypress #addCouponIdAmend' : handleCouponKeyPress,
                    'click #clearCouponBtn' : handleRemoveCoupon,
                    'click .openLogin' : handleOpenLogin
                }));
            }
            let isRefreshed = false;
            CCRZ.pubSub.on("view:CartDetailView:refresh",function(view){
                setTimeout(() => {
                    runDefaultJsFunctions();
                }, 100);
                if(!isRefreshed){
                    isRefreshed = true;
                    view.params.sortBy = 'name';
                    let items = view.model.get('ECartItemsS');
                    items.changeSort(view.params.sortBy);
                    if(items != null){
                        UTIL.calculateSubscriptionPrices(items.models, view, 'cart');
                    }
                    view.saveToModel = function(event){
                        var view = this;
                        if (view.params.hasChanged) {
                            this.model.saveChanges(this.params.skipAutoCalc, function(response){
                                if (response.success) {
                                    this.attrQtyChanged = false;
                                    let items = CCRZ.cartDetailModel.attributes.ECartItemsS;
                                    UTIL.calculateSubscriptionPrices(items.models, CCRZ.cartDetailView, 'cart');
                                    view.render();
                                    setTimeout(() => {
                                        runDefaultJsFunctions();
                                        UTIL.hideLoader();
                                    }, 500);
                                    CCRZ.pubSub.trigger('cartChange', CCRZ.pagevars.currentCartID);
                                    view.params.hasChanged = false;
                                }
                                CCRZ.pubSub.trigger("pageMessage", response);
                            });
                        }
                    };
                    view.renderDesktop = function() {
                        var v = this;
                        this.setElement($(CCRZ.uiProperties.CartDetailView.desktop.selector));
                        $(CCRZ.uiProperties.CartDetailView.phone.selector).html('');
                        v.$el.html(v.templateDesktop(v.model.toJSON()));
                        runDefaultJsFunctions();
                        CCRZ.promoView.render();
                        UTIL.hideLoader();
                    };
                    items.sort();
                    view.render();
                }
            });
            function handleIncludedItems(event){
                let sku = event.currentTarget.dataset.sku, id = event.currentTarget.dataset.id;
                this.model.set('selectedSku', sku);
                this.model.set('selectedCartItemId', id);
                this.render();
                setTimeout(() => {
                    runDefaultJsFunctions();
                    $('#bundleFlow').modal({backdrop: true, show: true}); 
                    $('#bundleFlow').removeClass('fade');
                }, 300);
            }
            function handleCouponKeyPress(event){
                if (window.event && window.event.keyCode == 13 || event.which == 13) {
                    handleApplyCoupon(event);
                    return false;
                } else {
                    return true;
                }
            }
            function handleOpenLogin(event){
                $('#loginModal').modal({backdrop: true, show: true}); 
                $('#loginModal').removeClass('fade');
                $('.modal-backdrop').removeClass('fade');
            }
            function handleRemoveCoupon(event){
                UTIL.showLoader();
                var view = CCRZ.cartDetailView;
                let reqData = JSON.stringify({
                    "couponCode" : view.model.attributes.couponName,
                    "cartEncId" : CCRZ.pagevars.currentCartID
                });
                CCRZ.remoteActions.cartPageRemoting.className = 'DCMB2B_custCart_controller';
                CCRZ.remoteActions.cartPageRemoting.removeCouponSPT( reqData,function(res,event){
                    let isRemove = false;
                    if(res && res.success && res.data.isValid){
                        isRemove = true;
                    } else if(res && res.success && !res.data.isValid && res.data.isCouponValid){
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "couponMessagingSection-Error", res.data.message));
                        UTIL.hideLoader();
                    } else if(res && res.success && !res.data.isValid && !res.data.isCouponValid){
                        isRemove = true;
                    } else {
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "couponMessagingSection-Error", CCRZ.processPageLabelMap('KFB2B_cart_removeCouponError').toString()));
                        UTIL.hideLoader();
                    }
                    if(isRemove){
                        view.model.clearCoupon(view.params.skipAutoCalc, function(response){
                            if (response.success) {
                                view.render();
                                CCRZ.pubSub.trigger('cartChange', CCRZ.pagevars.currentCartID);
                            } else {
                                response.clearInclSectionsOnly = true;
                                CCRZ.pubSub.trigger("pageMessage", response);
                            }
                            UTIL.hideLoader();
                        });
                    }
                });
            }
            function handleApplyCoupon(event){ 
                UTIL.showLoader();
                let view = CCRZ.cartDetailView;
                if(view.model.attributes.EGB2BSubscriptionCartStatus == 'Amend'){
                    couponCode = $('#addCouponIdAmend').val();
                } else {
                    couponCode = $('#addCouponIdCart').val();
                }
                let reqData = JSON.stringify({
                    "couponCode" : couponCode,
                    "cartEncId" : CCRZ.pagevars.currentCartID
                });
                CCRZ.remoteActions.cartPageRemoting.className = 'DCMB2B_custCart_controller';
                CCRZ.remoteActions.cartPageRemoting.addCouponSPT( reqData,function(res,event){
                    let isApply = false;
                    if(res && res.success && res.data.isValid){
                        isApply = true;
                    } else if(res && res.success && !res.data.isValid && res.data.isCouponValid){
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "couponMessagingSection-Error", res.data.message));
                        UTIL.hideLoader();
                    } else if(res && res.success && !res.data.isValid && !res.data.isCouponValid){
                        isApply = true;
                    } else {
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "couponMessagingSection-Error", CCRZ.processPageLabelMap('KFB2B_cart_applyCouponError').toString()));
                        UTIL.hideLoader();
                    }
                    if(isApply){
                        view.model.applyCoupon(couponCode, view.params.skipAutoCalc, function(response){
                            if (response.success) {
                                view.render();
                                CCRZ.pubSub.trigger('cartChange', CCRZ.pagevars.currentCartID);
                                if (CCRZ.ga) {
                                    CCRZ.ga.handleApplyCoupon({'couponCode': response.data.couponName});
                                }
                            }
                            else {
                                response.clearInclSectionsOnly = true;
                                CCRZ.pubSub.trigger("pageMessage", response);
                            }
                            UTIL.hideLoader();
                        });
                    }
                });
            }
            function abandonCurrentCart(event){
                UTIL.showLoader();
                CCRZ.remoteActions.cartPageRemoting.className = 'DCMB2B_custCart_controller';
                CCRZ.remoteActions.cartPageRemoting.abandonCart(JSON.stringify({ 'cartId': CCRZ.pagevars.currentCartID}),function(res,event){
                    if(res && res.success){
                        window.open(UTIL.getNavigateURL('home', {}), '_self');
                    } else {
                    }
                });
            }
            function gotoProductDetail(event) {
                var objLink = $(event.target);
                var productId = objLink.data("id");
               // productDetails(id);
                document.location = "/"+CCRZ.pagevars.storefrontName+"/ccrz__ProductDetails?viewState=DetailView&cartID=" + CCRZ.pagevars.currentCartID + "&sku=" + productId+getCSRQueryString();
            }

            function autoRenew(event){
                UTIL.showLoader();
                let id = event.target.attributes["data-id"].value;
                let renewVal =  event.target.checked;
                let reqData = {"prodId": id, "autoRenewVal" : event.target.checked };
                setTimeout(() => {
                    CCRZ.remoteActions.cartPageRemoting.className = 'DCMB2B_custCart_controller';
                    CCRZ.remoteActions.cartPageRemoting.updateAutoRenew(JSON.stringify(reqData),function(res,event){
                        if(res && res.data && res.data.prodList && res.data.prodList.length > 0){
                            $('#cart_'+id). prop("checked", renewVal);
                            for(let i = 0; i < CCRZ.cartDetailModel.attributes.ECartItemsS.length; i++){
                                let currentCartItem = CCRZ.cartDetailModel.attributes.ECartItemsS.models[i];
                                if(id == currentCartItem.attributes.sfid){
                                    currentCartItem.attributes.DCMAutoRenew = renewVal;
                                }
                            }
                            let items = CCRZ.cartDetailModel.attributes.ECartItemsS;
                            UTIL.calculateSubscriptionPrices(items.models, CCRZ.cartDetailView, 'cart');
                            $('.hover-tooltip').remove();
                            CCRZ.cartDetailView.render();
                            setTimeout(() => {
                                runDefaultJsFunctions();
                                $('.hover-tooltip').remove();
                            }, 500);
                        }
                        UTIL.hideLoader();
                    });
                },1000);
            };

            function removeItemButton(event){
                UTIL.showLoader(); 
                var objLink = $(event.currentTarget);
                var parentElement = objLink.parents(".cart_item");
                var sfid = objLink.data("id");
                var view = this;
                var cartId = view.model.get('sfid');

                view.invokeContainerLoadingCtx($('.deskLayout'), 'removeItem', cartId, sfid, function (response, event) {
                    if (response.success && event.status) {
                        parentElement.fadeOut(2500);
                        view.model.priceFetch(view.params.skipAutoCalc, function (response, event){
                            CCRZ.pubSub.trigger('cartChange', CCRZ.pagevars.currentCartID);
                            CCRZ.pubSub.trigger("action:"+view.viewName+":cartItemsRefreshed", view);
                            view.render();
                        });
                    }
                }, {escape: false, timeout: 120000});
            }

            function goToCheckoutCustom(event) {
                var view = this, cartType = event.currentTarget.dataset.type;
                UTIL.showLoader();
                view.goToCheckout(event);
            }
            function addSingleQty(event){
                UTIL.showLoader();
                let min = parseInt(event.currentTarget.dataset.min)
                , max = parseInt(event.currentTarget.dataset.max)
                , issub = (event.currentTarget.dataset.issub=='true'?true:false)
                , quantity = parseInt($('#entry_' + event.currentTarget.dataset.sfid).val()), isCart = false;
                if(issub && ((quantity + min) <= max)){
                    isCart = true;
                } else if(!issub){
                    isCart = true;
                }
                if(isCart){
                    if(isCart){
                        CCRZ.cartDetailView.adjustQty(event, min, '.item_qtyIncrement');
                        CCRZ.cartDetailView.saveCart(event);
                    }
                } else {
                    UTIL.hideLoader();
                }
            };
            function removeSingleQty(event){
                UTIL.showLoader();
                let min = parseInt(event.currentTarget.dataset.min)
                , max = parseInt(event.currentTarget.dataset.max)
                , quantity = parseInt($('#entry_' + event.currentTarget.dataset.sfid).val());
                if((quantity - min) > 0){
                    CCRZ.cartDetailView.adjustQty(event, -min, '.item_qtyIncrement');
                    CCRZ.cartDetailView.saveCart(event);
                } else {
                    UTIL.hideLoader();
                }
            };
            function changeQuantity(event){
                UTIL.showLoader();
                let min = parseInt(event.currentTarget.dataset.min)
                , max = parseInt(event.currentTarget.dataset.max)
                , issub = (event.currentTarget.dataset.issub=='true'?true:false)
                , quantity = parseInt(event.currentTarget.value), isCart = false;
                if(issub && (quantity > max)){
                    quantity = max;
                } else if(quantity <=0){
                    quantity = 1;
                }
                $('#entry_' + event.currentTarget.dataset.sfid).val(quantity);
                CCRZ.cartDetailView.changeQuantity(event);
                CCRZ.cartDetailView.saveCart(event);
            };
            if(CCRZ.cartDetailView){
                CCRZ.cartDetailView.initValidationDesktop = function(){}
            } 

            CCRZ.remoteActions.cartPageRemoting =  _.extend(CCRZ.RemoteInvocation,{ 
                className : 'DCMB2B_custCart_controller', 
                addToCart : function( reqData,callback){ 
                    this.invokeCtx('addToCart', 
                        reqData,  
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                },
                removeTax : function( reqData,callback){ 
                    this.invokeCtx('removeTax', 
                        reqData,  
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                },
                abandonCart : function( reqData,callback){ 
                    this.invokeCtx('abandonCart', 
                        reqData,  
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                },
                getActiveSubscDetails : function( reqData,callback){ 
                    this.invokeCtx('getActiveSubscDetails', 
                        reqData,  
                        function(resp, evt){ 
                            if(callback){
                                callback(resp,evt);
                            }            
                        }, 
                        { 
                            buffer:false, 
                            nmsp : false 
                        } 
                    );
                }
            });
        }
    }
});

